<?php
// -----------------------------------------------------------------------
//
// $Id: session.php 17 2012-01-29 10:07:14Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

function sess_open()
{
    return true;
}

function sess_close()
{
    return true;
}

function sess_read($id)
{
    // Generate captcha
    $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    $random = '';
    srand((double)microtime() * 1000000);
    for ($i = 0; $i < 6; $i++)
    {
        $random .= $chars{rand() % strlen($chars)};
    }
    $GLOBALS['sql']->query('SELECT session_data, session_expiry
                            FROM ' . TABLE_SESSIONS . '
                            WHERE session_id = \'' . $id . '\'');
    $table_sessions = $GLOBALS['sql']->fetch();
    if (!$table_sessions['session_data'])
    {
        // The initial lifetime of sessions is 5 minutes
        $GLOBALS['sql']->query('INSERT INTO ' . TABLE_SESSIONS . ' (session_id, session_expiry)
                                VALUES (\'' . $id . '\', \'' . (time() + 300) . '\')');
        $_SESSION['user_id'] = 0;
        $_SESSION['user_captcha'] = $random;
        return true;
    }
    else
    {
        if ($table_sessions['session_expiry'] < time())
        {
            // Sessions are updated for periods of 5 minutes
            $GLOBALS['sql']->query('UPDATE ' . TABLE_SESSIONS . '
                                    SET session_expiry = \'' . (time() + 300) . '\'
                                    WHERE session_id = \'' . $id . '\'');
        }
        return $table_sessions['session_data'];
    }
}

function sess_write($id, $data)
{
    if (in_array('mysql', get_declared_classes()))
    {
        $sql = new mysql;
    }
    if (in_array('pgsql', get_declared_classes()))
    {
        $sql = new pgsql;
    }
    if (in_array('sqlite', get_declared_classes()))
    {
        $sql = new sqlite;
    }
    $sql->query('UPDATE ' . TABLE_SESSIONS . '
                 SET session_data = \'' . $data . '\'
                 WHERE session_id = \'' . $id . '\'');
    return true;
}

function sess_destroy($id)
{
    $GLOBALS['sql']->query('DELETE FROM ' . TABLE_SESSIONS . '
                            WHERE session_id = \'' . $id . '\'');
    $GLOBALS['sql']->query('UPDATE ' . TABLE_USERS . '
                            SET user_lastvisit = \'' . time() . '\'
                            WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
    return true;
}

function sess_gc($lifetime)
{
    $GLOBALS['sql']->query('DELETE FROM ' . TABLE_SESSIONS . '
                            WHERE session_expiry < \'' . (time() - $lifetime) . '\'');
    return true;
}

session_set_save_handler('sess_open', 'sess_close', 'sess_read', 'sess_write', 'sess_destroy', 'sess_gc');
session_start();

?>