<?php
// -----------------------------------------------------------------------
//
// $Id: index.php 193 2012-04-03 09:04:45Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

$invalid = preg_match('`(ftp|http|www)`i', $_SERVER['QUERY_STRING']);
if ($invalid != false)
{
    exit('Invalid query string. Exiting...');
}

error_reporting(E_ALL);

include('./../includes/config.php');
if (defined('SQL_TYPE') && defined('SQL_HOST') && defined('SQL_PORT') && defined('SQL_DATABASE') && defined('SQL_USER') && defined('SQL_PASSWORD'))
{
    switch (SQL_TYPE)
    {
        case 'mysql':
            include('./../includes/mysql.php');
            $sql = new mysql;
            break;
        case 'pgsql':
            include('./../includes/pgsql.php');
            $sql = new pgsql;
            break;
        case 'sqlite':
            include('./../includes/sqlite.php');
            $sql = new sqlite;
            break;
    }
}
include('./../includes/function.php');

if (strcmp(get_phpversion(), '5.4.0') < 0)
{
    ini_set('magic_quotes_runtime', 0);
    if (get_magic_quotes_gpc())
    {
        $_GET = strip_input_data($_GET);
        $_POST = strip_input_data($_POST);
        $_COOKIE = strip_input_data($_COOKIE);
    }
}
if (defined('SQL_TYPE') && SQL_TYPE != 'sqlite')
{
    $_GET = slash_input_data($_GET);
    $_POST = slash_input_data($_POST);
    $_COOKIE = slash_input_data($_COOKIE);
}

$error = '';

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
  "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>GENU - Installation</title>
<link href="./../templates/default/style.css" type="text/css" rel="stylesheet" />
<!--[if IE 6]><link href="./../templates/default/ie6.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 7]><link href="./../templates/default/ie7.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 8]><link href="./../templates/default/ie8.css" type="text/css" rel="stylesheet"><![endif]-->
<meta http-equiv="content-language" content="en" />
<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />
</head>
<body>
<div class="pageMain">
  <div class="pageLeft">
    <div class="leftLogo"><img src="./../images/logo.png" alt="." title="GENU" /></div>
  </div>
  <div class="pageRight">';

if (isset($_GET['step']) && $_GET['step'] == 2)
{
    echo '
    <div class="rightMain">
      <div class="rightTop">Please choose your database type.</div>
      <form method="post" action="./index.php">
      <div class="formLeft">Database type:</div>
      <div class="formRight"><select name="sql_type"><option value="mysql">MySQL</option><option value="pgsql">PostgreSQL</option><option value="sqlite">SQLite</option></select></div>
      <div class="formLeft">&nbsp;</div>
      <div class="formRight"><input type="submit" value="Send" name="add_type" /></div>
      </form>
    </div>';
}
elseif (isset($_POST['add_type']))
{
    $data = "<?php\n";
    $data .= "// Database config file\n";
    $data .= "define('SQL_TYPE', '" . $_POST['sql_type'] . "');\n";
    if ($_POST['sql_type'] == 'sqlite')
    {
        $data .= "define('SQL_HOST', '');\n";
        $data .= "define('SQL_PORT', '');\n";
        $data .= "define('SQL_DATABASE', './../db/genu.db');\n";
        $data .= "define('SQL_USER', '');\n";
        $data .= "define('SQL_PASSWORD', '');\n";
    }
    $data .= "?>";

    $handle = './../includes/config.php';
    if ($fp = @fopen($handle, 'wb'))
    {
        flock($fp, LOCK_EX);
        fwrite($fp, $data, strlen($data));
        flock($fp, LOCK_UN);
        fclose($fp);
    }
    else
    {
        $error = 'Unable to open "' . $handle . '" file.';
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        if ($_POST['sql_type'] == 'sqlite')
        {
            echo '
    <div class="rightMain">Database added successfully.<br /><br /><a href="./index.php?step=3" title="Next step">Next step &gt;</a></div>';
        }
        else
        {
            $default_port = '';
            if ($_POST['sql_type'] == 'mysql')
            {
                $default_port = '3306';
            }
            if ($_POST['sql_type'] == 'pgsql')
            {
                $default_port = '5432';
            }
            echo '
    <div class="rightMain">
      <div class="rightTop">Please fill in the form with your database settings.</div>
      <form method="post" action="./index.php">
        <div class="formLeft">Host:</div>
        <div class="formRight"><input type="text" name="sql_host" size="25" maxlength="256" value="' . $_SERVER['SERVER_NAME'] . '" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Port:</div>
        <div class="formRight"><input type="text" name="sql_port" size="25" maxlength="5" value="' . $default_port . '" /></div>
        <div class="formLeft">Name:</div>
        <div class="formRight"><input type="text" name="sql_name" size="25" maxlength="128" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">User:</div>
        <div class="formRight"><input type="text" name="sql_user" size="25" maxlength="128" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Password:</div>
        <div class="formRight"><input type="password" name="sql_password" size="25" maxlength="32" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">&nbsp;</div>
        <div class="formRight"><input type="submit" value="Send" name="add_database" /></div>
      </form>
    </div>';
        }
    }
}
elseif (isset($_POST['add_database']))
{
    $data = "<?php\n";
    $data .= "// Database config file\n";
    $data .= "define('SQL_TYPE', '" . SQL_TYPE . "');\n";
    $data .= "define('SQL_HOST', '" . $_POST['sql_host'] . "');\n";
    $data .= "define('SQL_PORT', '" . $_POST['sql_port'] . "');\n";
    $data .= "define('SQL_DATABASE', '" . $_POST['sql_name'] . "');\n";
    $data .= "define('SQL_USER', '" . $_POST['sql_user'] . "');\n";
    $data .= "define('SQL_PASSWORD', '" . $_POST['sql_password'] . "');\n";
    $data .= "?>";

    $handle = './../includes/config.php';
    if ($fp = @fopen($handle, 'wb'))
    {
        flock($fp, LOCK_EX);
        fwrite($fp, $data, strlen($data));
        flock($fp, LOCK_UN);
        fclose($fp);
    }
    else
    {
        $error = 'Unable to open "' . $handle . '" file.';
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        echo '
    <div class="rightMain">Database added successfully.<br /><br /><a href="./index.php?step=3" title="Next step">Next step &gt;</a></div>';
    }
}
elseif (isset($_GET['step']) && $_GET['step'] == 3)
{
    $handle = './sql/' . SQL_TYPE . '.sql';
    if ($fp = @fopen($handle, 'rb'))
    {
        $content = fread($fp, filesize($handle));
        fclose($fp);
        preg_match_all('`CREATE[^;]+;`', $content, $matches);
        $queries = $matches[0];
        for ($i = 0; $i < count($queries); $i++)
        {
            $sql->query($queries[$i]);
        }
    }
    else
    {
        $error = 'Unable to open "' . $handle . '" file.';
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        echo '
    <div class="rightMain">Tables added successfully.<br /><br /><a href="./index.php?step=4" title="Next step">Next step &gt;</a></div>';
    }
}
elseif (isset($_GET['step']) && $_GET['step'] == 4)
{
    echo '
    <div class="rightMain">
      <div class="rightTop">Please fill in the form with a username, a password and a valid e-mail address.</div>
      <form method="post" action="./index.php">
        <div class="formLeft">Username:</div>
        <div class="formRight"><input type="text" name="user_name" size="25" maxlength="128" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Password:</div>
        <div class="formRight"><input type="password" name="user_password" size="25" maxlength="32" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Password (confirmation):</div>
        <div class="formRight"><input type="password" name="user_password2" size="25" maxlength="32" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">E-mail:</div>
        <div class="formRight"><input type="text" name="user_email" size="25" maxlength="256" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">&nbsp;</div>
        <div class="formRight"><input type="submit" value="Send" name="add_user" /></div>
      </form>
    </div>';
}
elseif (isset($_POST['add_user']))
{
    if (!trim($_POST['user_name']))
    {
        $error .= 'You must supply a username.<br />';
    }
    else
    {
        if (strlen($_POST['user_name']) < 3)
        {
            $error .= sprintf('Username must be at least %s characters long.<br />', 3);
        }
    }
    if (!trim($_POST['user_password']))
    {
        $error .= 'You must supply a password.<br />';
    }
    else
    {
        if (strlen($_POST['user_password']) < 6)
        {
            $error .= sprintf('Password must be at least %s characters long.<br />', 6);
        }
        if (trim($_POST['user_password2']) != trim($_POST['user_password']))
        {
            $error .= 'Passwords don\'t match.<br />';
        }
    }
    if (!trim($_POST['user_email']))
    {
        $error .= 'You must supply an e-mail address.<br />';
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        $sql->query('INSERT INTO genu_users (user_level, user_name, user_password, user_email, user_creation, user_ip, user_key)
                     VALUES (\'4\', \'' . chars2entities($_POST['user_name'], ENT_QUOTES) . '\', \'' . sha1($_POST['user_password']) . '\', \'' . $_POST['user_email'] . '\', \'' . time() . '\', \'' . $_SERVER['REMOTE_ADDR'] . '\', \'0\')');
        $sql->query('INSERT INTO genu_settings (sender_email, sender_name)
                     VALUES (\'' . $_POST['user_email'] . '\', \'' . chars2entities($_POST['user_name'], ENT_QUOTES) . '\')');
        echo '
    <div class="rightMain">User added successfully.<br /><br /><a href="./index.php?step=5" title="Next step">Next step &gt;</a></div>';
    }
}
elseif (isset($_GET['step']) && $_GET['step'] == 5)
{
    $siteurl = !empty($_SERVER['HTTP_HOST']) ? 'http://' . $_SERVER['HTTP_HOST'] . dirname(dirname($_SERVER['PHP_SELF'])) : 'http://';
    echo '
    <div class="rightMain">
      <div class="rightTop">Please fill in the form with your site name and URL.</div>
      <form method="post" action="./index.php">
        <div class="formLeft">Site name:</div>
        <div class="formRight"><input type="text" name="sitename" size="25" maxlength="128" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Site URL:</div>
        <div class="formRight"><input type="text" name="siteurl" size="25" maxlength="256" value="' . $siteurl . '" />&nbsp;<span class="asterisk">*</span></div>
        <div class="formLeft">Install smilies ?</div>
        <div class="formRight"><select name="add_smilies"><option value="0">No</option><option value="1" selected="selected">Yes</option></select></div>
        <div class="formLeft">&nbsp;</div>
        <div class="formRight"><input type="submit" value="Send" name="add_settings" /></div>
      </form>
    </div>';
}
elseif (isset($_POST['add_settings']))
{
    if (!trim($_POST['sitename']))
    {
        $error .= 'You must supply a site name.<br />';
    }
    if (!trim($_POST['siteurl']))
    {
        $error .= 'You must supply a site URL.<br />';
    }
    if ($_POST['add_smilies'] == 1)
    {
        $handle = './sql/smilies.sql';
        if ($fp = @fopen($handle, 'rb'))
        {
            $content = fread($fp, filesize($handle));
            fclose($fp);
            preg_match_all('`INSERT[^\n]+\n`', $content, $matches);
            $queries = $matches[0];
            for ($i = 0; $i < count($queries); $i++)
            {
                $sql->query($queries[$i]);
            }
        }
        else
        {
            $error = 'Unable to open "' . $handle . '" file.';
        }
    }
    else
    {
        foreach (glob('./../images/smilies/*.gif') as $filename)
        {
            if (!$filename)
            {
                $error = 'Unable to delete "' . $filename . '" file.';
            }
            else
            {
                unlink($filename);
            }
        }
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        $sql->query('UPDATE genu_settings
                     SET sitename = \'' . chars2entities($_POST['sitename'], ENT_QUOTES) . '\', siteurl = \'' . rtrim($_POST['siteurl'], ' /') . '\'');
        echo '
    <div class="rightMain">Settings added successfully.<br /><br />The installation is finished, please remove the install folder from your server.<br /><br />Go to the <a href="./../index.php" title="Home">index page</a> of your website.</div>';
    }
}
else
{
    echo '
    <div class="rightMain">
      Welcome to GENU installation.<br /><br />In order to have GENU working completely, the following is required:<br /><br />
      <ul>
        <li>A webserver or web hosting account</li>
        <li>PHP 4.3.0 or higher (with <a href="http://www.php.net/manual/en/function.mail.php" title="mail()">mail()</a> function and <a href="http://www.php.net/manual/en/book.image.php" title="GD library">GD library</a> enabled, preferably)</li>
        <li>A MySQL database (4.1 or higher) or a PostgreSQL database (7.0 or higher) or SQLite database support in PHP 5.x</li>
      </ul>
      <br />Please, also read <a href="./../readme.txt" title="readme.txt">readme.txt</a> before continuing.<br /><br /><a href="./index.php?step=2" title="Next step">Next step &gt;</a>
    </div>';
}

echo '
    <div class="rightBottom">Back to home</div>
  </div>
</div>
<div class="pageBottom"><a href="http://www.gnew.fr/" title="GENU">GENU</a> 2012.3, Copyright &copy; 2003-2012 Raoul Proen&ccedil;a</div>
</body>
</html>';

?>