# -----------------------------------------------------------------------
#
# $Id: 2012.1-sqlite.sql 120 2012-03-22 22:36:32Z raoul $
#
# Copyright (C) 2003-2012 Raoul Proena
# License: GNU GPL version 3 (see copying.txt file)
# Website: http://www.gnew.fr/
#
# -----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# -----------------------------------------------------------------------

# SETTINGS

CREATE TABLE tmp_genu_settings (
    sitename CHARACTER VARYING(512) NOT NULL DEFAULT '',
    siteurl CHARACTER VARYING(256) NOT NULL DEFAULT '',
    language CHARACTER VARYING(32) NOT NULL DEFAULT 'english',
    language_unique CHARACTER(1) NOT NULL DEFAULT '0',
    template CHARACTER VARYING(32) NOT NULL DEFAULT 'default',
    template_unique CHARACTER(1) NOT NULL DEFAULT '0',
    news_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    comments_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    headlines_per_backend CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    threads_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '20',
    posts_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '20',
    polls_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    users_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    news_order CHARACTER VARYING(10) NOT NULL DEFAULT 'news_date',
    allow_html CHARACTER(1) NOT NULL DEFAULT '0',
    allow_smilies CHARACTER(1) NOT NULL DEFAULT '1',
    submit_news CHARACTER(1) NOT NULL DEFAULT '1',
    send_news CHARACTER(1) NOT NULL DEFAULT '1',
    register_users CHARACTER(1) NOT NULL DEFAULT '1',
    sender_email CHARACTER VARYING(256) NOT NULL DEFAULT '',
    sender_name CHARACTER VARYING(512) NOT NULL DEFAULT '',
    date_format CHARACTER VARYING(32) NOT NULL DEFAULT 'D, M jS Y, g:i a',
    date_offset CHARACTER VARYING(3) NOT NULL DEFAULT '0',
    accounts_expiry CHARACTER VARYING(3) NOT NULL DEFAULT '30',
    cookies_expiry CHARACTER VARYING(3) NOT NULL DEFAULT '30',
    min_usernames_length CHARACTER VARYING(2) NOT NULL DEFAULT '3',
    min_passwords_length CHARACTER VARYING(2) NOT NULL DEFAULT '6',
    pages_limit CHARACTER VARYING(2) NOT NULL DEFAULT '10',
    search_limit CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    posts_interval CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    votes_interval CHARACTER VARYING(2) NOT NULL DEFAULT '1',
    max_texts_length CHARACTER VARYING(4) NOT NULL DEFAULT '1000',
    max_avatars_pixels CHARACTER VARYING(3) NOT NULL DEFAULT '64'
);

INSERT INTO tmp_genu_settings (sitename, siteurl, language, language_unique, template, template_unique, news_per_page, comments_per_page, headlines_per_backend, threads_per_page, posts_per_page, polls_per_page, users_per_page, news_order, allow_html, allow_smilies, submit_news, send_news, register_users, sender_email, sender_name, date_format, date_offset, accounts_expiry, cookies_expiry, min_usernames_length, min_passwords_length, pages_limit, search_limit, posts_interval, votes_interval, max_texts_length)
SELECT sitename, siteurl, language, language_unique, template, template_unique, news_per_page, comments_per_page, headlines_per_backend, threads_per_page, posts_per_page, polls_per_page, users_per_page, news_order, allow_html, allow_smilies, submit_news, send_news, register_users, sender_email, sender_name, date_format, date_offset, accounts_expiry, cookies_expiry, min_usernames_length, min_passwords_length, pages_limit, search_limit, posts_interval, votes_interval, max_texts_length
FROM genu_settings;

DROP TABLE genu_settings;

CREATE TABLE genu_settings (
    sitename CHARACTER VARYING(512) NOT NULL DEFAULT '',
    siteurl CHARACTER VARYING(256) NOT NULL DEFAULT '',
    language CHARACTER VARYING(32) NOT NULL DEFAULT 'english',
    language_unique CHARACTER(1) NOT NULL DEFAULT '0',
    template CHARACTER VARYING(32) NOT NULL DEFAULT 'default',
    template_unique CHARACTER(1) NOT NULL DEFAULT '0',
    news_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    comments_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    headlines_per_backend CHARACTER VARYING(2) NOT NULL DEFAULT '7',
    threads_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '20',
    posts_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '20',
    polls_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    users_per_page CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    news_order CHARACTER VARYING(10) NOT NULL DEFAULT 'news_date',
    allow_html CHARACTER(1) NOT NULL DEFAULT '0',
    allow_smilies CHARACTER(1) NOT NULL DEFAULT '1',
    submit_news CHARACTER(1) NOT NULL DEFAULT '1',
    send_news CHARACTER(1) NOT NULL DEFAULT '1',
    register_users CHARACTER(1) NOT NULL DEFAULT '1',
    sender_email CHARACTER VARYING(256) NOT NULL DEFAULT '',
    sender_name CHARACTER VARYING(512) NOT NULL DEFAULT '',
    date_format CHARACTER VARYING(32) NOT NULL DEFAULT 'D, M jS Y, g:i a',
    date_offset CHARACTER VARYING(3) NOT NULL DEFAULT '0',
    accounts_expiry CHARACTER VARYING(3) NOT NULL DEFAULT '30',
    cookies_expiry CHARACTER VARYING(3) NOT NULL DEFAULT '30',
    min_usernames_length CHARACTER VARYING(2) NOT NULL DEFAULT '3',
    min_passwords_length CHARACTER VARYING(2) NOT NULL DEFAULT '6',
    pages_limit CHARACTER VARYING(2) NOT NULL DEFAULT '10',
    search_limit CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    posts_interval CHARACTER VARYING(2) NOT NULL DEFAULT '30',
    votes_interval CHARACTER VARYING(2) NOT NULL DEFAULT '1',
    max_texts_length CHARACTER VARYING(4) NOT NULL DEFAULT '1000',
    max_avatars_pixels CHARACTER VARYING(3) NOT NULL DEFAULT '64'
);

INSERT INTO genu_settings (sitename, siteurl, language, language_unique, template, template_unique, news_per_page, comments_per_page, headlines_per_backend, threads_per_page, posts_per_page, polls_per_page, users_per_page, news_order, allow_html, allow_smilies, submit_news, send_news, register_users, sender_email, sender_name, date_format, date_offset, accounts_expiry, cookies_expiry, min_usernames_length, min_passwords_length, pages_limit, search_limit, posts_interval, votes_interval, max_texts_length)
SELECT sitename, siteurl, language, language_unique, template, template_unique, news_per_page, comments_per_page, headlines_per_backend, threads_per_page, posts_per_page, polls_per_page, users_per_page, news_order, allow_html, allow_smilies, submit_news, send_news, register_users, sender_email, sender_name, date_format, date_offset, accounts_expiry, cookies_expiry, min_usernames_length, min_passwords_length, pages_limit, search_limit, posts_interval, votes_interval, max_texts_length
FROM tmp_genu_settings;

DROP TABLE tmp_genu_settings;

# USERS

CREATE TABLE tmp_genu_users (
    user_id INTEGER UNSIGNED NOT NULL,
    user_level CHARACTER(1) NOT NULL DEFAULT '1',
    user_name CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_password CHARACTER VARYING(40) NOT NULL DEFAULT '',
    user_email CHARACTER VARYING(256) NOT NULL DEFAULT '',
    user_viewemail CHARACTER(1) NOT NULL DEFAULT '0',
    user_website CHARACTER VARYING(256) NOT NULL DEFAULT '',
    user_location CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_occupation CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_comments INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_posts INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_votes INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_creation INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_ip CHARACTER VARYING(15) NOT NULL DEFAULT '',
    user_language CHARACTER VARYING(32) NOT NULL DEFAULT 'english',
    user_template CHARACTER VARYING(32) NOT NULL DEFAULT 'default',
    user_date_format CHARACTER VARYING(32) NOT NULL DEFAULT 'D, M jS Y, g:i a',
    user_date_offset CHARACTER VARYING(3) NOT NULL DEFAULT '0',
    user_lastvisit INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_key CHARACTER VARYING(40) NOT NULL DEFAULT '',
    user_day CHARACTER VARYING(2) NOT NULL DEFAULT '0',
    user_month CHARACTER VARYING(2) NOT NULL DEFAULT '0',
    user_year CHARACTER VARYING(4) NOT NULL DEFAULT '0',
    user_avatar CHARACTER VARYING(256) NOT NULL DEFAULT './../images/avatars/empty.png',
    PRIMARY KEY (user_id)
);

INSERT INTO tmp_genu_users (user_id, user_level, user_name, user_password, user_email, user_viewemail, user_website, user_location, user_occupation, user_comments, user_posts, user_votes, user_creation, user_ip, user_language, user_template, user_date_format, user_date_offset, user_lastvisit, user_key, user_day, user_month, user_year)
SELECT user_id, user_level, user_name, user_password, user_email, user_viewemail, user_website, user_location, user_occupation, user_comments, user_posts, user_votes, user_creation, user_ip, user_language, user_template, user_date_format, user_date_offset, user_lastvisit, user_key, user_day, user_month, user_year
FROM genu_users;

DROP TABLE genu_users;

CREATE TABLE genu_users (
    user_id INTEGER UNSIGNED NOT NULL,
    user_level CHARACTER(1) NOT NULL DEFAULT '1',
    user_name CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_password CHARACTER VARYING(40) NOT NULL DEFAULT '',
    user_email CHARACTER VARYING(256) NOT NULL DEFAULT '',
    user_viewemail CHARACTER(1) NOT NULL DEFAULT '0',
    user_website CHARACTER VARYING(256) NOT NULL DEFAULT '',
    user_location CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_occupation CHARACTER VARYING(512) NOT NULL DEFAULT '',
    user_comments INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_posts INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_votes INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_creation INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_ip CHARACTER VARYING(15) NOT NULL DEFAULT '',
    user_language CHARACTER VARYING(32) NOT NULL DEFAULT 'english',
    user_template CHARACTER VARYING(32) NOT NULL DEFAULT 'default',
    user_date_format CHARACTER VARYING(32) NOT NULL DEFAULT 'D, M jS Y, g:i a',
    user_date_offset CHARACTER VARYING(3) NOT NULL DEFAULT '0',
    user_lastvisit INTEGER UNSIGNED NOT NULL DEFAULT '0',
    user_key CHARACTER VARYING(40) NOT NULL DEFAULT '',
    user_day CHARACTER VARYING(2) NOT NULL DEFAULT '0',
    user_month CHARACTER VARYING(2) NOT NULL DEFAULT '0',
    user_year CHARACTER VARYING(4) NOT NULL DEFAULT '0',
    user_avatar CHARACTER VARYING(256) NOT NULL DEFAULT './../images/avatars/empty.png',
    PRIMARY KEY (user_id)
);

INSERT INTO genu_users (user_id, user_level, user_name, user_password, user_email, user_viewemail, user_website, user_location, user_occupation, user_comments, user_posts, user_votes, user_creation, user_ip, user_language, user_template, user_date_format, user_date_offset, user_lastvisit, user_key, user_day, user_month, user_year)
SELECT user_id, user_level, user_name, user_password, user_email, user_viewemail, user_website, user_location, user_occupation, user_comments, user_posts, user_votes, user_creation, user_ip, user_language, user_template, user_date_format, user_date_offset, user_lastvisit, user_key, user_day, user_month, user_year
FROM tmp_genu_users;

DROP TABLE tmp_genu_users;

# END