<?php
// -----------------------------------------------------------------------
//
// $Id: browse.php 2 2012-01-24 17:39:30Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['NEWS_BROWSE_TITLE']);

$category_name_options = '<option></option>';
$sql->query('SELECT category_id, category_name
             FROM ' . TABLE_CATEGORIES . '
             WHERE category_level IN (\'0\', \'2\')
             ORDER BY category_name');
while ($table_categories = $sql->fetch())
{
    $category_name_options .= '<option value="' . $table_categories['category_id'] . '">' . $table_categories['category_name'] . '</option>';
}

$month_list = array('01' => $lang['JANUARY'],
                    '02' => $lang['FEBRUARY'],
                    '03' => $lang['MARCH'],
                    '04' => $lang['APRIL'],
                    '05' => $lang['MAY'],
                    '06' => $lang['JUNE'],
                    '07' => $lang['JULY'],
                    '08' => $lang['AUGUST'],
                    '09' => $lang['SEPTEMBER'],
                    '10' => $lang['OCTOBER'],
                    '11' => $lang['NOVEMBER'],
                    '12' => $lang['DECEMBER']);
$news_month_options = '<option></option>';
$sql->query('SELECT DISTINCT news_month
             FROM ' . TABLE_NEWS . '
             ORDER BY news_month');
while ($table_news = $sql->fetch())
{
    $news_month_options .= '<option value="' . $table_news['news_month'] . '">' . $month_list[$table_news['news_month']] . '</option>';
}

$news_year_options = '<option></option>';
$sql->query('SELECT DISTINCT news_year
             FROM ' . TABLE_NEWS . '
             ORDER BY news_year');
while ($table_news = $sql->fetch())
{
    $news_year_options .= '<option>' . $table_news['news_year'] . '</option>';
}

$template->set_file('browse', 'news/browse.htpl');
$template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                         'BROWSE' => $lang['BROWSE'],
                         'CATEGORY_NAME_OPTIONS' => $category_name_options,
                         'FORM_CATEGORY_NAME' => $lang['FORM_CATEGORY_NAME'],
                         'FORM_NEWS_MONTH' => $lang['FORM_NEWS_MONTH'],
                         'FORM_NEWS_YEAR' => $lang['FORM_NEWS_YEAR'],
                         'NEWS_BROWSE_HEADER' => $lang['NEWS_BROWSE_HEADER'],
                         'NEWS_MONTH_OPTIONS' => $news_month_options,
                         'NEWS_YEAR_OPTIONS' => $news_year_options));
$template->parse('browse');

page_footer();

?>