<?php
// -----------------------------------------------------------------------
//
// $Id: login.php 137 2012-03-23 18:25:13Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['USERS_LOGIN_TITLE']);

// User logged ?
if ($_SESSION['user_id'] != 0)
{
    error_template($lang['USERS_LOGIN_ERROR1']);
}
else
{
    // From login form ?
    if (isset($_POST['login']))
    {
        $sql->query('SELECT user_id, user_key, user_level
                     FROM ' . TABLE_USERS . '
                     WHERE user_name = \'' . chars2entities($_POST['user_name'], ENT_QUOTES) . '\'
                     AND user_password = \'' . sha1($_POST['user_password']) . '\'');
        $table_users = $sql->fetch();
        // Check user
        if (!$table_users['user_id'])
        {
            error_template($lang['USERS_LOGIN_ERROR2']);
        }
        // Active account ?
        elseif ($table_users['user_key'] != 0)
        {
            error_template($lang['USERS_LOGIN_ERROR3']);
        }
        // Banned user ?
        elseif ($table_users['user_level'] == 0)
        {
            error_template($lang['USERS_LOGIN_ERROR3']);
        }
        else
        {
            // Moderator ?
            if ($table_users['user_level'] > 1)
            {
                $_SESSION['check_latest'] = 0;
            }
            $sql->query('UPDATE ' . TABLE_USERS . '
                         SET user_ip = \'' . $_SERVER['REMOTE_ADDR'] . '\'
                         WHERE user_id = \'' . $table_users['user_id'] . '\'');
            $_SESSION['user_id'] = $table_users['user_id'];
            success_template($lang['USERS_LOGIN_SUCCESS'], './../index.php');
        }
    }
    // Login form
    else
    {
        $template->set_file('login', 'users/login.htpl');
        $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                                 'FORM_USER_NAME' => $lang['FORM_USER_NAME'],
                                 'FORM_USER_PASSWORD' => $lang['FORM_USER_PASSWORD'],
                                 'LOGIN' => $lang['LOGIN'],
                                 'USERS_LOGIN_HEADER' => $lang['USERS_LOGIN_HEADER']));
        $template->parse('login');
    }
}

page_footer();

?>