<?php
// -----------------------------------------------------------------------
//
// $Id: password.php 151 2012-03-25 17:30:52Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['USERS_PASSWORD_TITLE']);

// From password form ?
if (isset($_POST['password']))
{
    $error = '';
    $sql->query('SELECT user_email, user_id
                 FROM ' . TABLE_USERS . '
                 WHERE user_name = \'' . chars2entities($_POST['user_name'], ENT_QUOTES) . '\'
                 OR user_email = \'' . $_POST['user_email'] . '\'');
    $table_users = $sql->fetch();
    if (!trim($_POST['user_name']) && !trim($_POST['user_email']))
    {
        $error .= $lang['USERS_PASSWORD_ERROR1'];
    }
    else
    {
        // Check user
        if (!$table_users['user_id'])
        {
            $error .= $lang['USERS_PASSWORD_ERROR2'];
        }
    }
    if ($error)
    {
        error_template($error);
    }
    else
    {
        // Generate new password - 8 chars
        $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        $new_password = '';
        srand((double)microtime() * 1000000);
        for ($i = 0; $i < 8; $i++)
        {
            $new_password .= $chars{rand() % strlen($chars)};
        }

        $subject = sprintf($lang['USERS_PASSWORD_SUBJECT'], html_entity_decode($settings['sitename'], ENT_QUOTES, 'ISO-8859-1'));
        $message = sprintf($lang['USERS_PASSWORD_MESSAGE'], $new_password, html_entity_decode($settings['sender_name'], ENT_QUOTES, 'ISO-8859-1'), $settings['siteurl']);
        $header = 'From: ' . html_entity_decode($settings['sender_name'], ENT_QUOTES, 'ISO-8859-1') . ' <' . $settings['sender_email'] . '>' . "\n";
        $header .= 'Reply-To: ' . html_entity_decode($settings['sender_name'], ENT_QUOTES, 'ISO-8859-1') . ' <' . $settings['sender_email'] . '>' . "\n";
        $header .= 'X-Mailer: PHP/' . phpversion() . "\n";
        $header .= 'MIME-Version: 1.0' . "\n";
        $header .= 'Content-Type: text/plain; charset=iso-8859-1' . "\n";
        mail($table_users['user_email'], $subject, $message, $header);
        $sql->query('UPDATE ' . TABLE_USERS . '
                     SET user_password = \'' . sha1($new_password) . '\'
                     WHERE user_id = \'' . $table_users['user_id'] . '\'');
        success_template($lang['USERS_PASSWORD_SUCCESS'], './../index.php');
    }
}
// Password form
else
{
    $template->set_file('password', 'users/password.htpl');
    $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                             'FORM_USER_EMAIL' => $lang['FORM_USER_EMAIL'],
                             'FORM_USER_NAME' => $lang['FORM_USER_NAME'],
                             'SEND' => $lang['SEND'],
                             'USERS_PASSWORD_HEADER' => $lang['USERS_PASSWORD_HEADER']));
    $template->parse('password');
}

page_footer();

?>